<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  TeamOpsCardSection,
  TeamOpsFeatures,
  TeamOpsHero,
  TeamOpsJoinUsSection,
  TeamOpsSpotlight,
  TeamOpsVideoSpotlight,
} from '../../components/team-ops/index.vue';
import { NextStepAlt } from '../../components/common/index.vue';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful.js';
import { teamOpsDataHelper } from '~/services/teamops/teamops.service';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  name: 'TeamOps',
  components: {
    TeamOpsHero,
    TeamOpsSpotlight,
    TeamOpsFeatures,
    TeamOpsVideoSpotlight,
    TeamOpsCardSection,
    TeamOpsJoinUsSection,
    NextStepAlt,
  },
  async asyncData({ i18n }) {
    try {
      const query = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        include: 10,
        'sys.id': `21QxTW2DyILSaFMncoIZdv`,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const entryFields = query.items[0]?.fields;
      const teamOps = await teamOpsDataHelper(entryFields);
      return { teamOps };
      // Use the 'teamOps' variable as needed
    } catch (error) {
      throw new Error(error);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).teamOps,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <section class="team-ops">
    <TeamOpsHero :data="teamOps.hero" />
    <TeamOpsSpotlight :data="teamOps.spotlight" />
    <TeamOpsFeatures :data="teamOps.features" />
    <TeamOpsVideoSpotlight :data="teamOps.video_spotlight" />
    <TeamOpsCardSection :data="teamOps.card_section" />
    <TeamOpsJoinUsSection :data="teamOps.join_us" />
    <NextStepAlt />
  </section>
</template>

<style lang="scss" scoped>
.team-ops {
  :deep {
    .slp-btn-secondary {
      &:hover,
      &:focus {
        background: $color-primary-200;
        color: $color-primary-300;
      }
    }
  }
}
</style>
